package ProjectStormtrooper;

import javax.swing.*;
import java.awt.*;
import java.util.Random;
import java.awt.event.ActionListener;

public class FormStormtrooper {
    DrawingStormtrooper _drawingStormtrooper = new DrawingStormtrooper();
    private JButton buttonCreate;
    private JPanel pictureBox;
    private JButton buttonDown;
    private JButton buttonUp;
    private JButton buttonLeft;
    private JButton buttonRight;

    public JPanel getPictureBox() {
        return pictureBox;
    }

    public FormStormtrooper() {
        buttonUp.setName("buttonUp");
        buttonDown.setName("buttonDown");
        buttonLeft.setName("buttonLeft");
        buttonRight.setName("buttonRight");

        buttonCreate.addActionListener(e -> {
            _drawingStormtrooper = new DrawingStormtrooper();
            Random random = new Random();

            _drawingStormtrooper.Init(
                    random.nextInt(100, 300),
                    random.nextInt(1000, 3000),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                    new Color(random.nextInt(256), random.nextInt(256), random.nextInt(256)),
                    random.nextBoolean(),
                    random.nextBoolean(),
                    pictureBox.getWidth(),
                    pictureBox.getHeight()
            );

            _drawingStormtrooper.SetEnginesCount(random.nextInt(2, 7));
            _drawingStormtrooper.SetPosition(random.nextInt(10, 100), random.nextInt(10, 100));

            Draw();
        });

        ActionListener buttonMoveClickedListener = e -> {
            String buttonName = ((JButton) e.getSource()).getName();

            switch (buttonName) {
                case ("buttonUp") -> {
                    _drawingStormtrooper.MoveTransport(EnumDirectionType.Up);
                }
                case ("buttonDown") -> {
                    _drawingStormtrooper.MoveTransport(EnumDirectionType.Down);
                }
                case ("buttonLeft") -> {
                    _drawingStormtrooper.MoveTransport(EnumDirectionType.Left);
                }
                case ("buttonRight") -> {
                    _drawingStormtrooper.MoveTransport(EnumDirectionType.Right);
                }
            }

            Draw();
        };

        buttonUp.addActionListener(buttonMoveClickedListener);
        buttonDown.addActionListener(buttonMoveClickedListener);
        buttonLeft.addActionListener(buttonMoveClickedListener);
        buttonRight.addActionListener(buttonMoveClickedListener);
    }

    public void Draw() {
        if (_drawingStormtrooper.EntityStormtrooper == null) {
            return;
        }

        Graphics g = pictureBox.getGraphics();
        pictureBox.paint(g);
        _drawingStormtrooper.DrawTransport(g);
    }
}
